import React, { useEffect, useState } from 'react'
import { Select } from 'antd'
import styles from './index.less'
import { GetAreaSourceType, ReloadTableFields } from '../../../../../apis/process'

const AreaOption = [
  { label: '管网巡检', value: '管网巡检' },
  { label: 'DMA分区', value: 'DMA分区' },
  { label: 'DMA检漏', value: 'DMA检漏' },
  { label: 'DMA报警', value: 'DMA报警' },
]

const AreaSync = (props) => {

  const { value, onChange, schema, addons } = props
  const { tableNameParent } = addons.formData

  const [AreaOption, setAreaOption] = useState([])
  const [fieldOption, setFieldOption] = useState([])
  const [fieldValue, setFieldValue] = useState('')

  const AreaFocus = async () => {
    const { code, data } = await GetAreaSourceType()
    if (code === 0) {
      setAreaOption(data.map(v => ({ label: v, value: v })))
    }
  }

  const fieldFocus = async () => {
    if (!tableNameParent) {
      return message.info('请选择表名!')
    }
    const { code, data, msg } = await ReloadTableFields({ tableName: tableNameParent })
    if (code === 0) {
      let result = data.root.map(v => { return { label: v.name, value: v.name } })
      setFieldOption(result)
    } else {
      message.error(msg)
    }
  }

  const fieldChange = (value) => {
    addons.setValueByPath('areaSyncField', value)
    setFieldValue(value)
  }

  useEffect(() => {
    setFieldValue(addons?.getValue('areaSyncField') || '')
  }, [])

  return (
    <div className={styles.AreaSync}>
      <Select
        style={{ width: 110, marginRight: 10 }}
        onFocus={AreaFocus}
        options={AreaOption}
        value={value}
        allowClear
        placeholder='请选择区域来源'
        onChange={value => onChange(value)}
      />
      <Select
        style={{ width: 170 }}
        placeholder='请选择数据回填字段'
        value={fieldValue}
        onFocus={fieldFocus}
        options={fieldOption}
        onChange={fieldChange}
        allowClear
      />
    </div>
  )

}

export default AreaSync